[tox]
envlist = py37, py38, py39, py310, docs, pylint


[testenv]
deps =
    wheel
    -r {toxinidir}/requirements_test.txt
passenv = BASELINE_MOVE_UPDATES
setenv =
    BASELINE_PRINT_DIFFS = YES
    BASELINE_UPDATES_PATH = {envtmpdir}/.baseline_updates
    BASELINE_RELPATH_BASE = {toxinidir}
ignore_errors=true
commands =
    python -m pytest --log-level DEBUG --cov plum --cov-config "{toxinidir}/.coveragerc" \
        --cov-report html:"{envtmpdir}/coverage" --cov-fail-under=100 \
        --html "{envtmpdir}/test_report.html" "{toxinidir}/tests"

    # run tests that ensure boost doesn't mess up reference counts on what it operates on
    #  - validate tests measure reference counts right (good assumption python gets it right)
    #  - don't include this in coverage as tests messes with reference counts
    # python -m pytest --log-level DEBUG "{toxinidir}/boost/tests"


[testenv:docs]
basepython = python3.9
deps =
    -r {toxinidir}/docs/requirements.txt
commands =
    python -m sphinx.cmd.build -W -b html docs "{envtmpdir}/html"


[testenv:black]
basepython = python3.9
deps =
    -r {toxinidir}/requirements_black.txt
commands =
    python -m black --check .


[testenv:mypy]
basepython = python3.9
deps =
    -r {toxinidir}/requirements_mypy.txt
    -r {toxinidir}/requirements_test.txt
commands =
    python -m mypy src


[testenv:pylint]
basepython = python3.9
deps =
    -r {toxinidir}/requirements_pylint.txt
    -r {toxinidir}/requirements_test.txt
ignore_errors=true
commands =
    python -m pylint_fail_under --rcfile "{toxinidir}/.pylintrc" --fail_under 10.00 setup.py src/plum
    python -m pylint_fail_under --rcfile "{toxinidir}/.pylintrc" --disable=import-error,no-self-use,missing-function-docstring,missing-class-docstring,wrong-import-order \
         --fail_under 10.0 tests
